package QBS;
/*
 * author: kchantola
 */
import java.io.FileReader;
import java.util.Stack;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;


public class ParsingQP extends DefaultHandler
{
    String root;
    String fact;
    String[] dim = new String[10];
    int i;
    String function;
    String measure;
    Stack elementStack = new Stack();
    
    public static void main (String args[])
	throws Exception
    {
	XMLReader xr = XMLReaderFactory.createXMLReader();
	ParsingQP handler = new ParsingQP();
	xr.setContentHandler(handler);
	xr.setErrorHandler(handler);

        //Input file
        FileReader r = new FileReader("QP.xml");
        xr.parse(new InputSource(r));
    }

    ////////////////////////////////////////////////////////////////////
    // Event handlers.
    ////////////////////////////////////////////////////////////////////


    @Override
    public void startDocument ()
    {        
        System.out.println("Start document");
        i=0;
    }


    @Override
    public void endDocument ()
    {
        String[] mydim = new String[i];
        for(int j=0; j<dim.length; j++){
            if(dim[j]!= null){
                mydim[j] = dim[j];
            }
        }
        
        System.out.println("End document");
        System.out.println("root = " + root);
        System.out.println("fact = " + fact);
        for(int k=0; k<mydim.length; k++){
            System.out.println("dim[" + k + "] = " + mydim[k]);
        }
        System.out.println("function = " + function);
        System.out.println("measure = " + measure);
    }


    @Override
    public void startElement (String uri, String name, String qName, Attributes atts)
    {
        if (elementStack.empty()){
            root = qName;
        }
        else{
            if (qName.equals("groupby")){
                fact = elementStack.peek().toString();
            }
            else if (elementStack.peek().equals("groupby")){
                dim[i]=qName;
                i++;
            }
            else if (qName.equals("aggregation")){
                function = atts.getValue("function");
                measure = atts.getValue("measure");
            }
        }
        elementStack.push(qName);
    }


    @Override
    public void endElement (String uri, String name, String qName)
    {
        if(!elementStack.empty()){
            elementStack.pop();
        }
    }
    
    
    
}