package XWCH;

import java.io.IOException;
import java.util.Random;

/**
 *
 * @author kchantola
 */
public class ComplexDimensionLevels {
    private ReadingTable rt;
    private Random rand;
    private int nexticCounter;
    private int nextnsCounter;
    private int nextDimCounter;
    
    ComplexDimensionLevels(){
        rt = new ReadingTable();
        rand = new Random();
    }
    public String getDimensionLevels(String dimName, int id, int icCounter, int icInterval, 
            int nsCounter, int nsInterval, int nsNumber, int dimCounter) throws IOException{       
        
        String levelText = "";
        nexticCounter = icCounter;
        nextnsCounter = nsCounter;
        nextDimCounter = dimCounter;
        
        if(dimName.equals("part")){ 
            
            //incomplete only
            if(icInterval > 0 && dimCounter == icCounter && (nsNumber < 2 || dimCounter != nsCounter)){
                String line = rt.getLine("data/part.tbl", id);
                String category = rt.getLinePart(line, "|", 5);
                
                //start tag part
                String[] categoryName = {"type3", "type2", "type1"};
                levelText = "\n\t<" + dimName + " value=\'" + id + "\'>";
                //part levels
                //generate incomplete level
                //at least one level is incomplete, and at most all level are incomplete
                LevelArray la = new LevelArray();
                int[] type = la.geticLevels(3);
                for(int i=0; i<categoryName.length; i++){
                    if(i != type[i]){
                        int j = i + 1;
                        levelText = levelText 
                                + "<" + categoryName[i] + " value=\'" + rt.getLinePart(category, " ", j) + "\'>";
                    }
                }
                for(int i=categoryName.length - 1; i>=0; i--){
                    if(i != type[i]){
                        levelText = levelText + "</" + categoryName[i] + ">";
                    }
                }
                //end tag part
                levelText = levelText + "</" + dimName + ">";
            }
            
        
            //nonstrict only
            else if(nsNumber > 1 && dimCounter == nsCounter && (icInterval == 0 || dimCounter != icCounter)){
                //setting nonstrict array
                String[][] nsPart = new String[nsNumber][4];//4: 4 levels: part/type3/type2/type1
                LevelArray la = new LevelArray();
                nsPart = la.getPartArray(nsNumber, id);
                //write nonstrict array into xml
                String[] categoryName = {"part", "type3", "type2", "type1"};
                WritingNonStrictPartLevels wnsl = new WritingNonStrictPartLevels(nsPart, categoryName);                          
                wnsl.writeForward(0);
                levelText = wnsl.getnsText();
            }
            
            //complex (both incomplete & nonstrict
            else if(nsNumber > 1 && dimCounter == nsCounter && icInterval > 0 && dimCounter == icCounter){
                 //setting nonstrict array
                String[][] nsPart = new String[nsNumber][4];//4: 4 levels: part/type3/type2/type1
                LevelArray la = new LevelArray();
                nsPart = la.getPartArray(nsNumber, id);
                
                //setting complex array
                nsPart = la.getComplexPartArray(nsPart);
                //write nonstrict array into xml
                String[] categoryName = {"part", "type3", "type2", "type1"};
                WritingComplexPartLevels wnsl = new WritingComplexPartLevels(nsPart, categoryName);                          
                wnsl.writeForward(0);
                levelText = wnsl.getnsText();
                
            }
            //noncomplex
            else{
                String line = rt.getLine("data/part.tbl", id);
                String category = rt.getLinePart(line, "|", 5);
                
                //start tag part
                levelText = "\n\t<" + dimName + " value=\'" + id + "\'>";
                //part levels
                String[] categoryName = {"type3", "type2", "type1"};
                for(int i=0; i<categoryName.length; i++){
                    int j = i + 1;
                    levelText = levelText 
                            + "<" + categoryName[i] + " value=\'" + rt.getLinePart(category, " ", j) + "\'>";
                    
                }
                for(int i=categoryName.length - 1; i>=0; i--){
                    levelText = levelText + "</" + categoryName[i] + ">";
                }
                //end tag part
                levelText = levelText + "</" + dimName + ">";
            }
        }
        
 //=========================================================================    
        //customer 
        else if (dimName.equals("customer")){
            String line = "";
            //incomplete only
            if(icInterval > 0 && dimCounter == icCounter && (nsNumber < 2 || dimCounter != nsCounter)){
                
                LevelArray la = new LevelArray();
                int[] cusLocation = la.geticLevels(2) ;                
                NationRegion nr = new NationRegion("data/customer.tbl", id);
                
                //nation
                if(cusLocation[0] != 0){
                    levelText = "<nation value=\'" + nr.getNation() + "\'>";
                }
                
                //region
                if(cusLocation[1] != 1){
                    levelText = levelText + "<region value=\'" + nr.getRegion() + "\'>"
                            + "</region>";
                }
                //end tage of nation
                if(cusLocation[0] != 0){
                    levelText = levelText + "</nation>";
                }
            }
            
            //nonstrict only
            else if(nsNumber > 1 && dimCounter == nsCounter && (icInterval == 0 || dimCounter != icCounter)){
                //setting nonstrict array
                String[][] nsNation = new String[nsNumber][2];//4: 2 levels: nation/region
                
                NationRegion nr = new NationRegion("data/customer.tbl", id);
                LevelArray la = new LevelArray();
                nsNation = la.getNationArray(nsNumber, nr.getNationid());
                
                //write nonstrict array into xml
                String[] nationRegionName = {"nation", "region"};
                WritingNonStrictNationLevels wnsn = new WritingNonStrictNationLevels(nsNation, nationRegionName);                          
                wnsn.writeForward(0);
                levelText = wnsn.getnsText() + "\n\t";
            }
            
            //complex (both incomplete & nonstrict
            else if(nsNumber > 1 && dimCounter == nsCounter && icInterval > 0 && dimCounter == icCounter){
                //setting nonstrict array
                String[][] nsNation = new String[nsNumber][2];//4: 2 levels: nation/region
                
                NationRegion nr = new NationRegion("data/customer.tbl", id);
                LevelArray la = new LevelArray();
                nsNation = la.getNationArray(nsNumber, nr.getNationid());
                
                //setting complex array
                nsNation = la.getComplexNationArray(nsNation);
                
                //write nonstrict array into xml
                String[] nationRegionName = {"nation", "region"};
                WritingComplexNationLevels wcn = new WritingComplexNationLevels(nsNation, nationRegionName);                          
                wcn.writeForward(0);
                levelText = wcn.getnsText() + "\n\t";
            }
            
            //noncomplex
            else{
                NationRegion nr = new NationRegion("data/customer.tbl", id); 
                //nation
                levelText = "<nation value=\'" + nr.getNation() + "\'>";
                //region
                levelText = levelText + "<region value=\'" + nr.getRegion() + "\'>"
                            + "</region></nation>";
                
            }
          
        }
        
//=========================================================================            
        //supplier
        else{
            //incomplete only
            if(icInterval > 0 && dimCounter == icCounter && (nsNumber < 2 || dimCounter != nsCounter)){                
                //start tag supplier                
                levelText = "\n\t<" + dimName + " value=\'" + id + "\'>";
                
                //supplier levels
                //generate incomplete level
                //at least one level is incomplete, and at most all level are incomplete
                LevelArray la = new LevelArray();
                int[] supLocation = la.geticLevels(2) ;                
                NationRegion nr = new NationRegion("data/supplier.tbl", id);
                
                //nation
                if(supLocation[0] != 0){
                    levelText = levelText + "<nation value=\'" + nr.getNation() + "\'>";
                }
                
                //region
                if(supLocation[1] != 1){
                    levelText = levelText + "<region value=\'" + nr.getRegion() + "\'>"
                            + "</region>";
                }
                //end tage of nation
                if(supLocation[0] != 0){
                    levelText = levelText + "</nation>";
                }
                //end tag supplier
                levelText = levelText + "</" + dimName + ">";
            }
            
            //nonstrict only
            else if(nsNumber > 1 && dimCounter == nsCounter && (icInterval == 0 || dimCounter != icCounter)){
                //setting nonstrict array
                String[][] nsSupplier = new String[nsNumber][3];//3: 3 levels: supplier/nation/region
                LevelArray la = new LevelArray();
                nsSupplier = la.getSupplierArray(nsNumber, id);
                //write nonstrict array into xml
                String[] supplierLevelName = {"supplier", "nation", "region"};
                WritingNonStrictPartLevels wnsl = new WritingNonStrictPartLevels(nsSupplier, supplierLevelName);                          
                wnsl.writeForward(0);
                levelText = wnsl.getnsText();
            }
            //complex (both incomplete & nonstrict
            else if(nsNumber > 1 && dimCounter == nsCounter && icInterval > 0 && dimCounter == icCounter){
                //setting nonstrict array
                String[][] nsSupplier = new String[nsNumber][3];//3: 3 levels: supplier/nation/region
                LevelArray la = new LevelArray();
                nsSupplier = la.getSupplierArray(nsNumber, id);
                
                 //setting complex array
                nsSupplier = la.getComplexPartArray(nsSupplier);
                //write nonstrict array into xml
                String[] supplierLevelName = {"supplier", "nation", "region"};
                WritingComplexPartLevels wnsl = new WritingComplexPartLevels(nsSupplier, supplierLevelName);                          
                wnsl.writeForward(0);
                levelText = wnsl.getnsText();
            }
            
            //noncomplex
            else{
                //supplier start tag
                levelText = "\n\t<" + dimName + " value=\'" + id + "\'>";
                
                //location levels
                NationRegion nr = new NationRegion("data/supplier.tbl", id); 
                //nation
                levelText = levelText + "<nation value=\'" + nr.getNation() + "\'>";
                //region
                levelText = levelText + "<region value=\'" + nr.getRegion() + "\'>"
                            + "</region></nation>";
                
                //supplier end tag
                levelText = levelText + "</" + dimName + ">";
            }
        }
       
        nextDimCounter++;
        //set next incomplete counter
        if(icInterval>0 && (nextDimCounter % icInterval)==0){
            nexticCounter = nextDimCounter + rand.nextInt(icInterval);
        }
        if(nsInterval>0 && (nextDimCounter % nsInterval)==0){
            nextnsCounter = nextDimCounter + rand.nextInt(nsInterval);
        }
        return levelText;
   }
    
    public String getDateLevels(String date, int icCounter, int icInterval, int dimCounter){
        
        String levelText = "";
        nexticCounter = icCounter;
        nextDimCounter = dimCounter;
        int[] dateLevels = {-1, -1, -1};
        
        
        if(icInterval > 0 && dimCounter == icCounter){
            LevelArray la = new LevelArray();
            dateLevels = la.geticLevels(3);
        }
        
        String[] dateLevel = {"day", "month", "year"};
        for(int i=0; i<dateLevel.length; i++){
            if(dateLevels[i] != i){
            int j = i + 1;
                levelText = levelText + "<" + dateLevel[i] + " value=\'" + rt.getLinePart(date, "/", j) + "\'>";
            }
        }
        for(int i=dateLevel.length - 1; i>=0; i--){
            if(dateLevels[i] != i){
                levelText = levelText + "</" + dateLevel[i] + ">";
            }
        }  
        nextDimCounter++;
        //set next incomplete counter
        if(icInterval>0 && (nextDimCounter % icInterval)==0){
            nexticCounter = nextDimCounter + rand.nextInt(icInterval);
        }
        return levelText;
    }
    
    public int getNexticCounter(){
        return nexticCounter;
    }
    public int getNextnsCounter(){
        return nextnsCounter;
    }
    public int getNextDimCounter(){
        return nextDimCounter;
    }
}
