package XWCH;

import java.io.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;



import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.JDOMException;
import org.jdom2.input.SAXBuilder;

/**
 * 
 * @author M@hboubi
 */
public final class ComplexXML
{
    ArrayList dimensions_name;
    ArrayList measures_name;
    ArrayList dimensions_path;
    ArrayList outDimensions_path;
    String fact_name;
    ArrayList line_count;
    PrintWriter pwSale;
    PrintWriter pwPart;
    PrintWriter pwCustomer;
    PrintWriter pwSupplier;
    PrintWriter pwDate;
    double density ;//0<density<=1
    int factNumber;
    int icInterval;//Incomplete distributed interval
    int icCounter;//InComplete counter
    int nsInterval;//NonStrict distributed interval
    int nsCounter;//NonStrict counter
    int nsNumber;//NonStrict number
    int dimCounter;
    private int factCounter;
    Random rand;
    ReadingTable rt;
    ComplexDimensionLevels dl;
    String inFileName;
    String outFileName;
    
    private Hashtable part_ID;
    private Hashtable customer_ID;
    private Hashtable supplier_ID;
    private Hashtable date_ID;
  
    ComplexXML(double density, int factNumber, double icPercent, 
            double nsPercent, int nsNumber, String inFileName, String outFileName)
    {
        this.density = density;
        this.factNumber = factNumber;
        this.inFileName = inFileName;
        this.outFileName = outFileName;
        
        part_ID = new Hashtable();
        customer_ID = new Hashtable();
        supplier_ID = new Hashtable();
        date_ID = new Hashtable();
        
        icInterval = 0;
        if(icPercent>0){
            icInterval = (int) ((100.00/icPercent) + 0.5);//lump sum interval of percent
        }
        
        nsInterval = 0;
        if(nsPercent>0){
            nsInterval = (int) ((100.00/nsPercent) + 0.5);//lump sum interval of percent
        }
        this.nsNumber = nsNumber;
        
        rand = new Random();
        try {
            //parse("data/dw-model.xml");
            parse(inFileName);
            generateFact(outFileName);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ComplexXML.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(ComplexXML.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    //parsing data warehouse model
    public final void parse(String path) throws FileNotFoundException, IOException
    {
        dimensions_name = new ArrayList();
        measures_name = new ArrayList();
        dimensions_path = new ArrayList();
        outDimensions_path = new ArrayList();
        line_count = new ArrayList();
        rt = new ReadingTable();
        dl = new ComplexDimensionLevels();
        
        Document document = new Document();
        Element root;
        
        SAXBuilder sxb = new SAXBuilder();
        try
        {
                document = sxb.build(new File(path)); // "dw-model.xml"
        } catch (JDOMException | IOException e)
        {
                System.out.println(e);
        }
        
        root = document.getRootElement();

        Element fact_def = root.getChild("fact");

        fact_name = fact_def.getAttributeValue("id");

        List dimensions = fact_def.getChildren("dimension");
        Iterator i = dimensions.iterator();
        while (i.hasNext())
        {
                Element courant = (Element) i.next();
                dimensions_name.add(courant.getAttributeValue("idref"));
                dimensions_path.add(courant.getAttributeValue("idref") + ".tbl");
                outDimensions_path.add(courant.getAttributeValue("path"));

        }

        List measure = fact_def.getChildren("measure");
        i = measure.iterator();
        while (i.hasNext())
        {
                Element courant = (Element) i.next();
                measures_name.add(courant.getAttributeValue("id"));
        }

        for (int j = 0; j < dimensions_path.size(); j++)
        {
                String p = Integer.toString(rt.countLinedNumber("data/" + (String) dimensions_path.get(j)));
                line_count.add(p);//number of records in dimension tables
        }
    }//end of parse
    
    
    public void generateFact(String fileName) throws IOException
    {
        factCounter = 1;
        dimCounter = 0;
        icCounter = 0;
        if(icInterval>0){
            icCounter = rand.nextInt(icInterval);
        }
        
        nsCounter = 0;
        if(nsNumber>1 && nsInterval>0){
            nsCounter = rand.nextInt(nsInterval);
        }
        
        //fact:sale
        pwSale = new PrintWriter(fileName);
        pwSale.writeToXMLFile("<?xml version='1.0' encoding='UTF-8'?>");//head of fact xml file
        pwSale.bw.flush();
        pwSale.writeToXMLFile("\n<sales>");//fact document start tage as root
        pwSale.bw.flush();
        
        //Writing dimensions XML
        String outputPath = new java.io.File("").getAbsolutePath() + "\\outputDWXML\\";
        //dimension: part        
        pwPart = new PrintWriter(outputPath + (String) outDimensions_path.get(0));
        pwPart.writeToXMLFile("<?xml version='1.0' encoding='UTF-8'?>");
        pwPart.bw.flush();
        pwPart.writeToXMLFile("\n<parts>");
        pwPart.bw.flush();
        
        //dimension: customer        
        pwCustomer = new PrintWriter(outputPath + (String) outDimensions_path.get(1));
        pwCustomer.writeToXMLFile("<?xml version='1.0' encoding='UTF-8'?>");
        pwCustomer.bw.flush();
        pwCustomer.writeToXMLFile("\n<customers>");
        pwCustomer.bw.flush();
        
        //dimension: supplier        
        pwSupplier = new PrintWriter(outputPath + (String) outDimensions_path.get(2));
        pwSupplier.writeToXMLFile("<?xml version='1.0' encoding='UTF-8'?>");
        pwSupplier.bw.flush();
        pwSupplier.writeToXMLFile("\n<suppliers>");
        pwSupplier.bw.flush();
        
        //dimension: date        
        pwDate = new PrintWriter(outputPath + (String) outDimensions_path.get(3));
        pwDate.writeToXMLFile("<?xml version='1.0' encoding='UTF-8'?>");
        pwDate.bw.flush();
        pwDate.writeToXMLFile("\n<dates>");
        pwDate.bw.flush();
        
        outerloop:
        while(factCounter <= factNumber){
        
        //for each record of first dimension (part)
        for (int i = 1; i < Integer.parseInt((String) line_count.get(0)) + 1; i++)
        {
            //for each record of second dimension (customer)
            for (int j = 1; j < Integer.parseInt((String) line_count.get(1)) + 1; j++)
            {
                //for each record of third dimension (supplier)
                for (int k = 1; k < Integer.parseInt((String) line_count.get(2)) + 1; k++)
                {
                    
                    //for each record of fourth dimension (date)
                    for (int l = 1; l < Integer.parseInt((String) line_count.get(3)) + 1; l++){
                        //randomly selected by degree of density  
                        double randDensity = rand.nextDouble();
                        
                        if (randDensity < density)
                        {   

                            if(factCounter<=factNumber){
                                //fact
                                String txt = "";
                                txt = "\n<" + fact_name + " " + fact_name + "_value=\'" + factCounter + "\'>";
                                pwSale.writeToXMLFile(txt);
                                pwSale.bw.flush();


                                //dimensions
                                String dimName = "";
                                //part
                                dimName = (String) dimensions_name.get(0);
                                txt = dl.getDimensionLevels(dimName, i, icCounter, icInterval, 
                                        nsCounter, nsInterval, nsNumber, dimCounter);
                                pwSale.writeToXMLFile(txt);
                                pwSale.bw.flush();
                                icCounter = dl.getNexticCounter();
                                nsCounter = dl.getNextnsCounter();
                                dimCounter = dl.getNextDimCounter();
                                
                                if(part_ID.get(i) == null){
                                    String fn = "data/" + (String) dimensions_path.get(0);
                                    String dXML = getDimensionXML(0, fn, i);
                                    pwPart.writeToXMLFile(dXML);
                                    pwPart.bw.flush();
                                    part_ID.put(i, i);
                                }

                                //customer
                                dimName = (String) dimensions_name.get(1);
                                //Fact-Dimension incomplete (exclude anonymous customer)
                                if(icInterval > 0 && dimCounter == icCounter && rand.nextInt(3) == 0){
                                    dimCounter++;
                                    if(icInterval>0 && (dimCounter%icInterval) == 0){
                                        icCounter = dimCounter + rand.nextInt(icInterval);
                                    }
                                    if(nsInterval>0 && (dimCounter%nsInterval) == 0){
                                        nsCounter = dimCounter + rand.nextInt(nsInterval);
                                    }
                                }

                                else {
                                    txt = "\n\t<" + dimName + " value=\'" + j + "\'>";
                                    txt = txt + dl.getDimensionLevels(dimName, j, icCounter, icInterval, nsCounter, nsInterval, nsNumber, dimCounter);
                                    txt = txt + "</" + dimName + ">"; 
                                    pwSale.writeToXMLFile(txt);
                                    pwSale.bw.flush();
                                    icCounter = dl.getNexticCounter();
                                    dimCounter = dl.getNextDimCounter();
                                    nsCounter = dl.getNextnsCounter();

                                    if(customer_ID.get(j) == null){
                                        String fn = "data/" + (String) dimensions_path.get(1);
                                        String dXML = getDimensionXML(1, fn, j);
                                        pwCustomer.writeToXMLFile(dXML);
                                        pwCustomer.bw.flush();
                                        customer_ID.put(j, j);
                                    }
                                    
                                    
                                }


                                //supplier
                                dimName = (String) dimensions_name.get(2);
                                txt = dl.getDimensionLevels(dimName, k, icCounter, icInterval, 
                                        nsCounter, nsInterval, nsNumber, dimCounter);
                                pwSale.writeToXMLFile(txt);
                                pwSale.bw.flush();
                                icCounter = dl.getNexticCounter();
                                dimCounter = dl.getNextDimCounter();

                                if(supplier_ID.get(k) == null){
                                    String fn = "data/" + (String) dimensions_path.get(2);
                                    String dXML = getDimensionXML(2, fn, k);
                                    pwSupplier.writeToXMLFile(dXML);
                                    pwSupplier.bw.flush();
                                    supplier_ID.put(k, k);
                                }                                

                                //date
                                dimName = (String) dimensions_name.get(3);
                                String dateLine = rt.getLine("data/" + dimensions_path.get(3), l);
                                String value = rt.getLinePart(dateLine, "|", 1);
                                txt = "\n\t<" + dimName + " value=\'" + value + "\'>";
                                txt = txt + dl.getDateLevels(value, icCounter, icInterval, dimCounter);
                                txt = txt + "</" + dimName + ">"; 
                                
                                pwSale.writeToXMLFile(txt);
                                pwSale.bw.flush();
                                icCounter = dl.getNexticCounter();
                                dimCounter = dl.getNextDimCounter();
                                if(nsInterval>0 && (dimCounter % nsInterval)==0){
                                    nsCounter = dimCounter + rand.nextInt(nsInterval);
                                }
                                
                                if(date_ID.get(l) == null){
                                    String fn = "data/" + (String) dimensions_path.get(3);
                                    String dXML = getDateDimensionXML(dateLine);
                                    pwDate.writeToXMLFile(dXML);
                                    pwDate.bw.flush();
                                    date_ID.put(l, l);
                                }

                                //measure
                                //quantity
                                int quantity = 1 + rand.nextInt(1000) + nsInterval;
                                pwSale.writeToXMLFile("\n\t<" + measures_name.get(0) + " value=\'" + quantity + "\'></" + measures_name.get(0) + ">");
                                pwSale.bw.flush();
                                //totalamount
                                String line = rt.getLine("data/" + (String) dimensions_path.get(0), i);
                                double retailAmount = Double.valueOf(rt.getLinePart(line, "|", 8));
                                double totalAmount = quantity * retailAmount;
                                pwSale.writeToXMLFile("\n\t<" + measures_name.get(1) + " value=\'" + totalAmount + "\'></" +  measures_name.get(1) + ">");
                                pwSale.bw.flush();

                                pwSale.writeToXMLFile("\n</" + fact_name + ">");//end tage of fact
                                pwSale.bw.flush();
                                factCounter++;
                            }
                            else{
                                break outerloop;
                            }
                        }
                    }
                    
                }
            }
        } 
        }//end of while
        //write to f_sale.xml
        pwSale.writeToXMLFile("\n</sales>");
        pwSale.bw.flush();
        
        pwPart.writeToXMLFile("\n</parts>");
        pwPart.bw.flush();
        
        pwCustomer.writeToXMLFile("\n</customers>");
        pwCustomer.bw.flush();
        
        pwSupplier.writeToXMLFile("\n</suppliers>");
        pwSupplier.bw.flush();
        
        pwDate.writeToXMLFile("\n</dates>");
        pwDate.bw.flush();
    }
    
    public int getFactCounter(){
        return (factCounter - 1);
    }
    
    
    public String getDimensionXML(int dimID, String fileName, int lineNumber) throws IOException{
        ReadingTable drt = new ReadingTable();
        String dXML = "";
        String line = drt.getLine(fileName, lineNumber);        
        if(dimID == 0){            
            dXML = "\n\t<part p_key=\'" + drt.getLinePart(line, "|", 1) + "\'>\n"
            + "\t\t<name value=\'" + drt.getLinePart(line, "|", 2) + "\'></name>\n"
            + "\t\t<manufacturer value=\'" + drt.getLinePart(line, "|", 3) + "\'></manufacturer>\n"
            + "\t\t<brand value=\'" + drt.getLinePart(line, "|", 4) + "\'></brand>\n"
            + "\t\t<category value=\'" + drt.getLinePart(line, "|", 5) + "\'></category>\n"
            + "\t\t<size value=\'" + drt.getLinePart(line, "|", 6) + "\'></size>\n"
            + "\t\t<container value=\'" + drt.getLinePart(line, "|", 7) + "\'></container>\n"
            + "\t\t<retail_price value=\'" + drt.getLinePart(line, "|", 8) + "\'></retail_price>\n"
            + "\t\t<comment value=\'" + drt.getLinePart(line, "|", 9) + "\'></comment>\n"
            + "\t</part>";
        }
        else if(dimID == 1){
            dXML = "\n\t<customer c_key=\'" + drt.getLinePart(line, "|", 1) + "\'>\n"
            + "\t\t<name value=\'" + drt.getLinePart(line, "|", 2) + "\'></name>\n"
            + "\t\t<address value=\'" + drt.getLinePart(line, "|", 3) + "\'></address>\n"
            + "\t\t<nation_key n_key=\'" + drt.getLinePart(line, "|", 4) + "\'></nation_key>\n"
            + "\t\t<phone value=\'" + drt.getLinePart(line, "|", 5) + "\'></phone>\n"
            + "\t\t<acctbal value=\'" + drt.getLinePart(line, "|", 6) + "\'></acctbal>\n"
            + "\t\t<mksegment value=\'" + drt.getLinePart(line, "|", 7) + "\'></mksegment>\n"
            + "\t\t<comment value=\'" + drt.getLinePart(line, "|", 8) + "\'></comment>\n"
            + "\t</customer>";
        }
        else if(dimID == 2){
            dXML = "\n\t<supplier s_key=\'" + drt.getLinePart(line, "|", 1) + "\'>\n"
            + "\t\t<name value=\'" + drt.getLinePart(line, "|", 2) + "\'></name>\n"
            + "\t\t<address value=\'" + drt.getLinePart(line, "|", 3) + "\'></address>\n"
            + "\t\t<nation_key n_key=\'" + drt.getLinePart(line, "|", 4) + "\'></nation_key>\n"
            + "\t\t<phone value=\'" + drt.getLinePart(line, "|", 5) + "\'></phone>\n"
            + "\t\t<acctbal value=\'" + drt.getLinePart(line, "|", 6) + "\'></acctbal>\n"
            + "\t\t<comment value=\'" + drt.getLinePart(line, "|", 7) + "\'></comment>\n"
            + "\t</supplier>";
        }
        else if(dimID == 3){
            dXML = "\n\t<date value=\'" + drt.getLinePart(line, "|", 1) + "\'>\n"
            + "\t\t<dayName value=\'" + drt.getLinePart(line, "|", 2) + "\'></dayName>\n"
            + "\t</date>";
        }
        
        return dXML;
    }
    
    public String getDateDimensionXML(String line){
        ReadingTable drt = new ReadingTable();
        String dXML = "";
        dXML = "\n\t<date value=\'" + drt.getLinePart(line, "|", 1) + "\'>\n"
            + "\t\t<dayName value=\'" + drt.getLinePart(line, "|", 2) + "\'></dayName>\n"
            + "\t</date>";
        return dXML;
    }
}
